static char *rcsid = "$Header: /silver/homes/zeus/Blind-2.44/RCS/report-main.c,v 2.44 1995/12/31 19:45:18 zeus Exp zeus $";

/*
 * $Log: report-main.c,v $
 * Revision 2.44  1995/12/31  19:45:18  zeus
 * Revision 2.43  1995/03/20  01:43:09  zeus
 *
 */

#define NOTIMEB
#include "common.h"
#include "prototypes.h"
#include "report-g.h"
#include "report.h"
#include "misc-g.h"
#include "exit.h"
#include "options.h"

void report_main_rcsid (void);

void
report_main_rcsid (void)
{
  printf ("%s\n", rcsid);
}

#ifdef FORECAST
extern int seenlist[];
extern sorted *sorted_planets;

#endif

#ifdef GAMENAME
extern char gamename[MAXTEXT];

#endif

extern char buf[256];
extern planet *planets;
extern int turn;
extern player *players;
FILE *pr;
int vieweropts;
char prname[MAXTEXT] = "con";
char optf[4];

int
player_dead (player * P)
{
  planet *p;

  for (p = planets; p && p->owner != P; p = p->next)
    ;                           /* Does he have Planets ? */

  if (!p && !P->groups)         /* No planets or groups... */
    return (1);
  return (0);
}

int
player_footnote (player * P)
{
  planet *p;
  group *g;

  for (p = planets; p && p->owner != P; p = p->next)
    ;                           /* Does he have Planets ? */

  if (p)
    return (0);                 /* Planets, so still OK */

  for (g = P->groups; g; g = g->next)
  {
    if ((g->type->cargo > 0.0) && (g->loadtype == CG_COL) && (g->load > 0.0))
      return (0);               /* Has a group with COL on board, so OK */
  }
  return (1);                   /* No pop, or COL- You are a goner... */
}

typedef struct strlist_s
{
  struct strlist_s *next;
  char *s[20];
}
strlist;


char *fheading;
strlist *fdata;
int fcolumns, fcol;
char *ftypes;
int headflag;

void
inputpr (void)
{
AGAIN:
  printf ("Output device? [%s] ", prname);
  getstr ();
  if (buf[0])
    strcpy (prname, buf);
  pr = stdout;
  if (hstricmp (prname, "con"))
    pr = fopen (prname, "w");
  if (pr == 0)
  {
    printf ("Can't open %s\n", prname);
    goto AGAIN;
  }
}


void
spf (char *s, double x)
{
  int i = 0;

  sprintf (s, "%0.2f", x);
  while (s[i])
    i++;
  while (i && s[i - 1] == '0')
    s[--i] = 0;
  if (i && s[i - 1] == '.')
    s[--i] = 0;
}

void
fpf (FILE * f, double x)
{
  spf (buf, x);
  fprintf (f, buf);
}

void
rpf (double x)
{
  fpf (pr, x);
}


void
ckunderscores (char *s)
{
  if (UNDERSCORES & vieweropts)
    while (*s)
    {
      if (*s == ' ')
        *s = '_';
      s++;
    }
}

void
fbegin (char *heading, char *types)
{
  fheading = strdup (heading);
  fcol = fcolumns = strlen (types);
  ftypes = types;
  fdata = 0;
}

void
fs (char *s)
{
  strlist *p2;
  static strlist *p;

  if (fcol == fcolumns)
  {
    p2 = alloc (sizeof (strlist) + fcolumns * sizeof (char *));

    addlist (&fdata, p2);
    p = p2;
    fcol = 0;
  }
  p->s[fcol++] = strdup (s);
  /* ckunderscores (p->s[fcol]); *//* Might work now, took ++ out */
}

void
ff (double a)
{
  sprintf (buf, "%0.2f", a);
  fs (buf);
}

void
fi (int n)
{
  sprintf (buf, "%d", n);
  fs (buf);
}

void
fend (void)
{
  int *width;
  int i, l;
  strlist *p;

  if (fdata && (!headflag || fdata->next))
  {
    if (*fheading)
      fprintf (pr, "\t\t%s\n\n", fheading);
    for (i = 0; i != fcolumns; i++)
      if (ftypes[i] == 'f')
      {
        int trunc = 1;

        for (p = fdata->next; p; p = p->next)
          if (p->s[i][0] && p->s[i][strlen (p->s[i]) - 1] != '0')
            trunc = 0;
        if (trunc)
        {
          for (p = fdata->next; p; p = p->next)
            if (p->s[i][0])
              p->s[i][strlen (p->s[i]) - 1] = 0;
          for (p = fdata->next; p; p = p->next)
            if (p->s[i][0] && p->s[i][strlen (p->s[i]) - 1] != '0')
              trunc = 0;
          if (trunc)
            for (p = fdata->next; p; p = p->next)
              if (p->s[i][0] && p->s[i][1])
                p->s[i][strlen (p->s[i]) - 2] = 0;
        }
      }
    width = alloc (fcolumns * sizeof (int));
    memset (width, 0, fcolumns * sizeof (int));

    for (p = fdata; p; p = p->next)
      for (i = 0; i != fcolumns; i++)
      {
        l = strlen (p->s[i]);
        if (l > width[i])
          width[i] = l;
      }
    for (p = fdata; p; p = p->next)
    {
      for (i = 0; i != fcolumns; i++)
      {
        l = width[i] - strlen (p->s[i]);
        if (ftypes[i] == 'x')
        {
          fprintf (pr, p->s[i]);
          while (--l >= 0)
            fputc (' ', pr);
        }
        else
        {
          while (--l >= 0)
            fputc (' ', pr);
          fprintf (pr, p->s[i]);
        }
        if (vieweropts & TWOSPACE)
          fprintf (pr, "  ");
        else
          fprintf (pr, " ");
      }
      fputc ('\n', pr);
    }
    fputc ('\n', pr);
    free (width);
  }
  for (p = fdata; p; p = p->next)
    for (i = 0; i != fcolumns; i++)
      free (p->s[i]);
  freelist (fdata);
  free (fheading);
  headflag = 0;
}

void
fhead (char *s)
{
  static char lbuf[2];

  if (fcol != strlen (s))
    fprintf (stderr, "Header length mismatch!");
  while (*s)
  {
    lbuf[0] = *s++;
    fs (lbuf);
  }
  headflag = 1;
}

#ifndef EDIT
void
option_on (char *ps, int opt, int popt)
{
  fprintf (pr, ps);
  if (ison (opt, popt))
    fprintf (pr, "on\n");
  else
    fprintf (pr, "off\n");

}

void
print_options (player * P)
{
  if (P->opts2 & SHOWOPT)
  {
    fprintf (pr, "\t\tOptions:\n");
    option_on ("Full reports (F) ", FULL, P->opts1);
    option_on ("Forecast         ", FCAST, P->opts2);
    option_on ("Long forecasts   ", LONGFORECAST, P->opts2);
    option_on ("Map printing     ", MAP, P->opts1);

#ifdef V3
    fprintf (pr, "Size:%6.2f centered X:%6.2f Y:%6.2f\n",
             (double) P->size, (double) P->x, (double) P->y);
#endif

    option_on ("Production       ", PROD, P->opts1);
    option_on ("Smartmap         ", MAPPLUS, P->opts1);
    option_on ("Unknown          ", UNKNOWN, P->opts1);
    if (((P->opts1 & MAP) && !(P->opts1 & UNKNOWN)) ||
        (!(P->opts1 & MAP) && (P->opts1 & UNKNOWN)))
      fprintf (pr, "An unknown planet list will be printed\n");
    else
      fprintf (pr, "An unknown planet list will NOT be printed\n");
    option_on ("Battlesum        ", BATTLESUM, P->opts1);
    option_on ("Longbattle       ", LONGBATTLE, P->opts1);
    option_on ("Battlemass       ", BATTLEMASS, P->opts1);
    option_on ("Bombsum          ", BOMBSUM, P->opts1);
    option_on ("Techs            ", TECHS, P->opts2);
    option_on ("Sortgroups       ", SORTGROUPS, P->opts2);
    option_on ("Sortplanets      ", SORTPLANETS, P->opts2);
    option_on ("Techplus         ", TECHPLUS, P->opts2);
    option_on ("Autounload       ", AUTOUNLOAD, P->opts2);
    option_on ("Upgradecost      ", UPCOST, P->opts2);
    option_on ("FullType         ", FULLTYPE, P->opts1);
    option_on ("Shortint         ", SHORTINT, P->opts1);
    option_on ("Showopts         ", SHOWOPT, P->opts2);
    option_on ("Unsafemax        ", UNSAFEMAX, P->opts2);
    fprintf (pr, "MAX will work on the highest group");
    if (P->opts2 & UNSAFEMAX)
      fprintf (pr, " ->NOT<- in hyperspace\n");
    else
      fprintf (pr, "\n");
    option_on ("Unsafebreak      ", UNSAFEBREAK, P->opts1);
    option_on ("Showfrom         ", SHOWFROM, P->opts2);
    fprintf (pr, "\n");
  }
}

void
print_incoming (player * P, planet * p)
{
  player *P2;
  group *g;

  fbegin ("Incoming Groups", "xxxxfff");
  fhead ("ONDNRSM");
  for (P2 = players; P2; P2 = P2->next)
    if (P2 != P)
      for (g = P2->groups; g; g = g->next)
        if (g->dist && g->where->owner == P &&
            (g->ships * shipmass (g)) > 1.0)
          /* Local report and planet, or global */
          if ((g->where == p) || p == NULL)
          {
            if (canseeplanet (P, g->from, 1))
              fs (g->from->name);
            else
              fs ("?");
            fs (g->from->num);
            fs (g->where->name);
            fs (g->where->num);
            ff (g->dist);

#ifdef UPGRADE
            if (g->fleet)
              ff (g->fleet->fleetspeed);
            else
#endif

              ff (group_speed (g->tech, g->type, shipmass (g)));
            /*ff (g->type->drive * g->tech.drive * DRIVEMAGIC / shipmass (g)); */
            ff (shipmass (g) * g->ships);
          }
  fend ();
}

#ifdef FORECAST
void
forecast_report (player * P)
{
  planet *p;
  sorted *s;


  vieweropts = P->opts2;

#ifdef FCASTNAMES
  {
    int i;

    i = strlen (P->name);
    while (i && P->name[i - 1] != ' ' && P->name[i - 1] != '\'')
      i--;
    sprintf (buf, "%s.F", P->name + i);
    pr = fopen (buf, "w");
  }

#ifdef VERBOSE
  printf ("Writing forecast file %s\n", buf);
#endif

#else
  pr = fopen ("forecast.F", "w");

#ifdef VERBOSE
  printf ("Writing forecast file forecast.F\n");
#endif

#endif

  if (pr == 0)
  {
    printf ("Can't open %s\n", buf);
    exit (BADREPORT);
  }

  print_options (P);

#ifdef GAMENAME
  strcpy (buf, P->name);
  ckunderscores (buf);
  fprintf (pr, "\t\tBlind Galaxy game %s Report for %s, Turn %d\n\n",
           gamename, buf, turn);
#else
  strcpy (buf, P->name);
  ckunderscores (buf);
  fprintf (pr, "\t\t%s FORECAST for Galaxy Turn %d\n\n", buf, turn);
#endif

  print_status (P, 0);
  print_shiptypes (P, 0);
  if (P->opts1 & MAP)
    domap (P);

  fbegin ("Your Systems", "xxffffffxfff");
  fhead ("N#XYSPIRPC$M");
  for (p = planets; p; p = p->next)
    if ((p->owner == P) && seenlist[ptonum (planets, p)])
      printplanet (p, P);
  fend ();

  if (P->opts1 & PROD)
  {
    fbegin ("Ships in Production", "xxffffxff");
    fhead ("N#IM$STCU");
    for (p = planets; p; p = p->next)
      if ((p->owner == P) && seenlist[ptonum (planets, p)])
        in_production (p);
    fend ();
  }

  print_routes (P);

#ifdef KCMD
  print_selective_defenses (P);
#endif

  print_alien_planets (P);
  if (((P->opts1 & MAP) && !(P->opts1 & UNKNOWN)) ||
      (!(P->opts1 & MAP) && (P->opts1 & UNKNOWN)))
  {
    fbegin ("Possible Unknown Systems", "xff");
    fhead ("#XY");
    for (p = planets; p; p = p->next)

#ifdef V3
      if ((!seenlist[ptonum (planets, p)]) &&
          (fabs (wrap (p->x - P->homex) - P->x) < (double) (P->size / 2)) &&
          (fabs (wrap (p->y - P->homey) - P->y) < (double) (P->size / 2)))
#else
      if ((!seenlist[ptonum (planets, p)]))
#endif

      {
        fs (p->num);
        ff (wrap (p->x - P->homex));    /* GE: relative coordinate fix */
        ff (wrap (p->y - P->homey));
      }
    fend ();
  }

  print_all_your_groups (P);

#ifdef UPGRADE
  print_your_fleets (P);
#endif

  if ((P->opts1 & FULL) && (P->opts2 & LONGFORECAST))
  {
    if (P->opts2 & SORTPLANETS)
      for (s = sorted_planets, p = s->p; s; s = s->next)
      {
        p = s->p;
        if ((seenlist[ptonum (planets, p)]) && (p->owner == P))
          print_full_planet (P, p);
      }
    else
      for (p = planets; p; p = p->next)
        if ((seenlist[ptonum (planets, p)]) && (p->owner == P))
          print_full_planet (P, p);
    print_full_alien_planets (P);
    print_unowned_planets (P);
    print_partial_reports (P);
  }

  if (pr && (pr != stdout))
    fclose (pr);
}
#else

#ifndef NEWGAME
void
report (player * P)
{
  planet *p;

  vieweropts = P->opts2;

  if (abs (P->lastorders) < turn)
  {
    fprintf (pr, "\t\tWarning!!!\nOrders were last received for turn %d\n\n\n",
             abs (P->lastorders));
  }


  if (player_dead (P))
  {
    fprintf (pr, "\tWe regret to inform you, but all your forces have been destroyed.\n");
    fprintf (pr, "This will be the last turn report for %s.\n\n\n", P->name);
  }
  else if (player_footnote (P) && (P->lastorders > 0))
  {

#ifdef GAMENAME
    fprintf (pr, "\tCongratulations %s, you are now an historic footnote in %s\n", P->name, gamename);
    fprintf (pr, "With no colonists or population, you have no way to build new ships.");
#else
    fprintf (pr, "\tCongratulations %s, you are now an historic footnote in the\n", P->name);
    fprintf (pr, "galaxy. With no colonists or population, you have no way to build new ships.");
#endif

    fprintf (pr, "Your only chances of winning are to arrange the depopulation of everyone");
    fprintf (pr, "else's systems, and then the destruction (or scrapping) of their\n");
    fprintf (pr, "remaining ships. Should you manage this from the early part of the\n");
    fprintf (pr, "game (or actually, any part but the last few turns), you will go down\n");
    fprintf (pr, "in history as the best galaxy player ever.\n\n");

    P->lastorders = -P->lastorders;     /* Do not repeat message */
  }
  else if ((turn < 5) && (!P->groups))
  {
    fprintf (pr, "WARNING: You have not produced any ships!\nYour species is in danger of becoming reproductively challenged!!\n\n");
  }

  print_options (P);

#ifdef GAMENAME
  strcpy (buf, P->name);
  ckunderscores (buf);
  fprintf (pr, "\t\tBlind Galaxy game %s Report for %s, Turn %d\n\n", gamename, buf, turn);
#else
  strcpy (buf, P->name);
  ckunderscores (buf);
  fprintf (pr, "\t\t%s Report for Galaxy Turn %d\n\n", buf, turn);
#endif

  print_status (P, 1);          /* Do the Status section */
  print_shiptypes (P, 1);       /* Print out visible ship types */
  print_battles (P);
  if (P->opts1 & BATTLEMASS)
    print_battle_sum (P);
  print_bombings (P);
  if (P->opts1 & BOMBSUM)
    print_bombing_summary (P);

  if (P->opts1 & MAP)
    domap (P);

  print_incoming (P, NULL);     /* Incoming report section */

  fbegin ("Your Systems", "xxffffffxfff");
  fhead ("N#XYSPIRPC$M");
  for (p = planets; p; p = p->next)
    if (p->owner == P)
      printplanet (p, P);
  fend ();

  if (P->opts1 & PROD)
  {
    fbegin ("Ships in Production", "xxffffxff");
    fhead ("N#IM$STCU");
    for (p = planets; p; p = p->next)
      if (p->owner == P)
        in_production (p);
    fend ();
  }
  print_routes (P);

#ifdef KCMD
  print_selective_defenses (P);
#endif

  print_alien_planets (P);
  print_uninhabited_planets (P);
  if (((P->opts1 & MAP) && !(P->opts1 & UNKNOWN)) ||
      (!(P->opts1 & MAP) && (P->opts1 & UNKNOWN)))
    print_unknown_planets (P);

  print_all_your_groups (P);

#ifdef UPGRADE
  print_your_fleets (P);
#endif

  print_alien_groups (P);

  /* GE: planet-group matrix */

  /* your planets */
  if (P->opts1 & FULL)
  {
    print_full_your_planets (P);
    print_full_alien_planets (P);
    print_unowned_planets (P);
    print_partial_reports (P);
  }
  if (pr && (pr != stdout))
    fclose (pr);
}
#endif

#endif

#endif
